<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import AdminProductModule from "~/store/adminCollection";
import _ from "lodash";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class adminShippingComponent extends Vue {
  adminProduct = getModule(AdminProductModule, this.$store);

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;
  page = 1;

  loadingTable = false;

  listShipping: any = [];
  loading = false;
  loadingId: any = "";
  editId = "";
  idxAdd: any = null;
  shippingId = "";

  dialogDelete = false;

  mounted() {
    this.onGetListShipping();
  }

  async onGetListShipping() {
    try {
      this.loadingTable = true;
      const response = await this.$api.shipping.allShippingAdmin(this.config);
      if (response?.data?.data) {
        this.listShipping = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onHandlerShipping(id: any) {
    try {
      const findShipping: any = this.listShipping.find(
        (shipping: any, i: number) => shipping._id === id || i === id
      );
      this.loadingId = id;
      const { price, desc, name, _id, quantity } = findShipping;
      if (!name) {
        return this.$pushNotification.error(
          "Shipping name cannot be left blank"
        );
      } else if (!desc) {
        return this.$pushNotification.error(
          "Shippng description cannot be left blank"
        );
      } else if (price < 1) {
        return this.$pushNotification.error(
          "Shipping price cannot be less than 1"
        );
      } else if (quantity < 1) {
        return this.$pushNotification.error("Quantity cannot be less than 1");
      }
      const payload = {
        name,
        price,
        desc,
        quantity,
      };
      if (_id) {
        await this.$api.shipping.edit(_id, payload);
        this.$pushNotification.success("Updated shipping successfully");
      } else {
        await this.$api.shipping.create(payload);
        this.$pushNotification.success("Created shipping successfully");
      }
      this.onGetListShipping();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingId = null;
      this.editId = "";
    }
  }

  addShipping() {
    this.listShipping.push({
      name: "Shippng name",
      desc: "",
      price: 0,
      quantity: 0,
    });
  }

  removeCombo(i: number) {
    this.listShipping.splice(i, 1);
  }
  openDialogDelete(id: any) {
    if (typeof id === "string") {
      this.shippingId = id;
      this.dialogDelete = true;
    } else {
      this.removeCombo(id);
    }
  }

  async onDeleteShipping() {
    try {
      this.loading = true;
      await this.$api.shipping.delete(this.shippingId);
      this.$pushNotification.success("Deleted shipping successfully");
      this.dialogDelete = false;
      this.onGetListShipping();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
}
</script>

<style></style>
